<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>
<body>
    
</body>
</html>

<script>
    class Employee {
        _firstName;
        _lastName;
        _socialSecurityNumber;

        constructor(paramFirstName, paramLastName, paramSSN) {
            this._firstName = paramFirstName;
            this._lastName = paramLastName;
            this._socialSecurityNumber = paramSSN;
        }

        testFun() {
            console.log(this._firstName + " is testing");
        }
    }

    class CommissionEmployee extends Employee {
        _grossSales;
        _commissionRate;

        constructor(paramFirstName, paramLastName, paramSSN, paramGrossSales, paramCommissionRate) {
            super(paramFirstName, paramLastName, paramSSN);
            this._grossSales = paramGrossSales;
            this._commissionRate = paramCommissionRate;
        }

        testFunCE() {
            console.log(this._grossSales + " is testing");
        }
    }

    class HourlyEmployee extends Employee {
        _wage;
        _hours;

        constructor(paramFirstName, paramLastName, paramSSN, paramWage, paramHours) {
            super(paramFirstName, paramLastName, paramSSN);
            this._wage = paramWage;
            this._hours = paramHours;
        }

        testFunHE() {
            console.log(this._wage + " is testing");
        }
    }

    class SalariedEmployee extends Employee {
        _weeklySalary;

        constructor(paramFirstName, paramLastName, paramSSN, paramWeeklySalary) {
            super(paramFirstName, paramLastName, paramSSN);
            this._weeklySalary = paramWeeklySalary;
        }

        testFunSE() {
            console.log(this._weeklySalary + " is testing");
        }
    }

    class BasePlusCommissionEmployee extends CommissionEmployee {
        _baseSalary;

        constructor(paramFirstName, paramLastName, paramSSN, paramGrossSales, paramCommissionRate, paramBaseSalary) {
            super(paramFirstName, paramLastName, paramSSN, paramGrossSales, paramCommissionRate);
            this._baseSalary = paramBaseSalary;
        }

        testFunBPCE() {
            console.log(this._baseSalary + " is testing");
        }
    }

    var vEmployee1 = new Employee("firstName1", "lastName1", "socialSecurityNumber1");
    console.log(vEmployee1);
    vEmployee1.testFun();
    console.log(vEmployee1 instanceof Employee);

    var vCommissionEmployee1 = new CommissionEmployee("firstName2", "lastName2", "socialSecurityNumber2", "grossSales1", "commissionRate1");
    console.log(vCommissionEmployee1);
    vCommissionEmployee1.testFun();
    vCommissionEmployee1.testFunCE();
    console.log(vCommissionEmployee1 instanceof CommissionEmployee);
    console.log(vCommissionEmployee1 instanceof Employee);

    var vHourlyEmployee1 = new HourlyEmployee("firstName3", "lastName3", "socialSecurityNumber3", "wage1", "hours1");
    console.log(vHourlyEmployee1);
    vHourlyEmployee1.testFun();
    vHourlyEmployee1.testFunHE();
    console.log(vHourlyEmployee1 instanceof CommissionEmployee);
    console.log(vHourlyEmployee1 instanceof HourlyEmployee);
    console.log(vHourlyEmployee1 instanceof Employee);

    var vSalariedEmployee1 = new SalariedEmployee("firstName4", "lastName4", "socialSecurityNumber4", "weeklySalary1");
    console.log(vSalariedEmployee1);
    vSalariedEmployee1.testFun();
    vSalariedEmployee1.testFunSE();
    console.log(vSalariedEmployee1 instanceof CommissionEmployee);
    console.log(vSalariedEmployee1 instanceof HourlyEmployee);
    console.log(vSalariedEmployee1 instanceof SalariedEmployee);
    console.log(vSalariedEmployee1 instanceof Employee);

    var vBasePlusCommissionEmployee1 = new BasePlusCommissionEmployee("firstName5", "lastName5", "socialSecurityNumber5", "grossSales2", "commissionRate2", "baseSalary1");
    console.log(vBasePlusCommissionEmployee1);
    vBasePlusCommissionEmployee1.testFun();
    vBasePlusCommissionEmployee1.testFunCE();
    vBasePlusCommissionEmployee1.testFunBPCE();
    console.log(vBasePlusCommissionEmployee1 instanceof CommissionEmployee);
    console.log(vBasePlusCommissionEmployee1 instanceof BasePlusCommissionEmployee);
    console.log(vBasePlusCommissionEmployee1 instanceof HourlyEmployee);
    console.log(vBasePlusCommissionEmployee1 instanceof SalariedEmployee);
    console.log(vBasePlusCommissionEmployee1 instanceof Employee);
</script>